#include <raleigh/w/padding.h>
#include <raleigh/w/button.h>
#include <raleigh/w/label.h>
#include <raleigh/w/entry.h>
#include <raleigh/w/vbox.h>

#include <raleigh/runtime.h>
#include <raleigh/window.h>

#include <popups/info.h>
#include <pland/pcrt.h>

using namespace raleigh;

window *p_w;

void onclick(button &from) {
  p_w->show();
}

void main() {
  label l("Hello, world! Close me with Alt+F4.");
  padding pl(l, 2);

  label bl("Click me!");
  padding pbl(bl, 4);
  button b(pbl, &onclick);
  padding pb(b, 2);

  entry e(8, 31, "This window is made with the Raleigh widget toolkit for Portland OS.\n\nI am a text entry widget. My cursor can be used, but editing is not yet implemented.");
  padding pe(e, 2);

  dllist<widget &> wl;
  wl.add_front(pe);
  wl.add_front(pb);
  wl.add_front(pl);
  vbox vb(wl);
  padding pvb(vb, 2);

  window w(pvb, RGB(bf, bf, bf), (bool (*)(window &))&__pcrt_quit);

  label p_l("You clicked that button!");
  padding p_pl(p_l, 4);
  p_w = new window(p_pl);

  w.show();
  start_runtime();
}